## evolver 2.70+ds

=== src/Makefile ===
# Makefile for Surface Evolver
SHELL= /bin/sh

# INSTRUCTIONS: Customize this makefile for your system by choosing
# your compiler (cc or gcc or whatever), and then uncomment the
# appropriate CFLAGS, GRAPH, and GRAPHLIB definitions for your system.
# If lines need to be modified for your system, please let me know
# at brakke@susqu.edu.

# The following systems have their own sections:
# Generic Unix 
# Linux OpenGL
# Linux OpenGL with 128-bit floating point quadmath library
# Linux Xwindows 
# cygwin 
# Mac OSX
# Sun Xwindows 
# 32-bint Solaris OpenGL 
# 64-bint Solaris OpenGL

# NOTE: -DOOGL should be specified in CFLAGS if you want Evolver to 
# be able to use geomview.  And -DOOGL is harmless in any case. 

# NOTE: You can use the readline input editing system (if your system has it)
# by adding -DUSE_READLINE to CFLAGS and  -lreadline -lcurses to GRAPHLIB.
# But beware; readline may be incompatible with using geomview.
# Also, the readline code was contributed by a user for version 2.30,
# and may be incompatible with readline libraries on some systems (Mac,
# for instance).

#-----------------------------------------------------------------------------

# Pick your compiler, and add any options you want, such as optimization.
# Can also add -DLONGDOUBLE to use the long double floating point datatype
# (but that is slower and not recommended for general use).

CC= gcc -O3 

#---------------------Start of system choices---------------------------------

# Remove #'s from following 3 lines for generic Unix without builtin graphics.
# Add -DOOGL to CFLAGS if you are using geomview.
#CFLAGS= -DGENERIC
#GRAPH= nulgraph.o 
#GRAPHLIB= 

#---- Generic Unix -----------------------------------------------------------

# Remove #'s from following 3 lines for generic Unix with X-windows. 
# Add -DOOGL to CFLAGS if you are using geomview.
# You might have to add something like -I/usr/X11R6/include to CFLAGS if 
# there is a problem finding Xlib.h while compiling xgraph.c, and add
# -L/usr/X11R6/lib to GRAPHLIB.
#CFLAGS= -DGENERIC
#GRAPH= xgraph.o 
#GRAPHLIB= -lX11 
#some places might have -lX11-mit

#----- Linux OpenGL ----------------------------------------------------------

# Remove #'s from following 3 lines for LINUX with OpenGL GLUT graphics.
# The graphics are on a second thread, so pthreads are needed.
# NOTE: -DPTRHEADS is necessary with glutgraph.o.
#CFLAGS= -DLINUX -DOOGL -DPTHREADS
#GRAPH= glutgraph.o 
#GRAPHLIB= -lGL -lGLU -lglut -lpthread
# NOTE: It has been reported to me that RedHat 9 needs the following line
# for GRAPHLIB, but earlier and later versions do okay with the GRAPHLIB
# line just above.
#GRAPHLIB= -lGL -lGLU -lglut -L/usr/X11R6/lib -lXi -lXmu -lpthread

#----- Linux OpenGL with __float128 and libquadmath  --------------------------
# 128-bit floating point in software (but 10 times slower).
# It's up to you to install the quadmath library.
# Remove #'s from following 3 lines for LINUX with OpenGL GLUT graphics.
# The graphics are on a second thread, so pthreads are needed.
# NOTE: -DPTRHEADS is necessary with glutgraph.o.
#CFLAGS= -DLINUX -DOOGL -DPTHREADS -DFLOAT128
#GRAPH= glutgraph.o 
#GRAPHLIB= -lGL -lGLU -lglut -lpthread /usr/lib64/libquadmath.so.0

#------ Linux Xwindows ------------------------------------------------------

# Remove #'s from following 3 lines for LINUX with crummy Xwindows graphics.
# You may have to modify the X11 lib path given here.
#CFLAGS= -DLINUX -DOOGL 
#GRAPH= xgraph.o 
#GRAPHLIB= -L/usr/X11R6/lib -lX11 

#-------- cygwin --------------------------------------------------------------

# Remove #'s from the following three lines for cygwin.
#CFLAGS= -DLINUX -DOOGL -DPTHREADS
#GRAPH= glutgraph.o 
#GRAPHLIB=   -lglut -lglu32 -lopengl32 -lpthread

#------- Mac OSX -------------------------------------------------------------

# Remove #'s from following 5 lines for MAC OSX with OpenGL GLUT graphics.
#INC=/System/Library/Frameworks/GLUT.framework/Versions/A/Headers
#CFLAGS= -DLINUX -DPTHREADS -DOOGL -DMAC_OS_X -I$(INC)
#GRAPH= glutgraph.o
#GLDIR=/System/Library/Frameworks/OpenGL.framework/Libraries
#GRAPHLIB= -L$(GLDIR)  -lGL -lGLU -lobjc  -framework GLUT

# Note: to get backward compatibility to older versions of Mac OSX, 
# add this to CFLAGS:   -mmacosx-version-min=10.4

#------- Sun Xwindows --------------------------------------------------------

# Remove #'s from following 3 lines for SUNs or SPARCSTATIONs with X-windows
# WARNING: If you use -O2 optimization, you may have to compile popfilm.c
# without optimization, because sun optimization may hang.
#CFLAGS= -DSUN -DOOGL -I/usr/openwin/include
#GRAPH= xgraph.o 
#GRAPHLIB= -L/usr/openwin/lib  -lX11 

#------- 32-bint Solaris OpenGL ------------------------------------------------------

# 32-bit SOLARIS with GLUT.  The GLUT graphics window runs in a separate
# thread;  -DPTHREADS enables threads in Evolver source code, and -mt
# enables it in the Solaris cc compiler.  For the gcc compiler, use -pthreads 
# instead of -mt.
# You should check to see that the GLUTHOME directory listed below exists;
# it may be some other place on your machine.  If you can't find it,
# download glut-3.7b.sparc_solaris.tar.gz from www.sun.com.
#GLUTHOME= /usr/local/sparc_solaris/glut-3.7
#INCLUDE= -I/usr/openwin/include -I$(GLUTHOME)/include
#CFLAGS= -DSUN -DOOGL -DGLUT -DPTHREADS -mt $(INCLUDE)
#GRAPH= glutgraph.o 
#GRAPHLIB= -L/usr/openwin/lib  -lX11 -L$(GLUTHOME)/lib/glut -lglut -lGL -lGLU -lXmu

#------- 64-bint Solaris OpenGL ------------------------------------------------------

# 64-bit SOLARIS with GLUT.  Also see 32 bit comments above.
# You should check to see that the GLUTHOME directory listed below exists;
# it may be some other place on your machine.  If you can't find it,
# download glut-3.7b.sparc_solaris_64.tar.gz from www.sun.com.
#GLUTHOME= /usr/local/sparc_solaris_64bit/glut-3.7
#INCLUDE= -I/usr/openwin/include -I$(GLUTHOME)/include
#CFLAGS= -DSUN -DOOGL -DGLUT -DPTHREADS -mt $(INCLUDE) -m64 
#GRAPH= glutgraph.o 
#GRAPHLIB= -L/usr/openwin/lib  -lX11 -L$(GLUTHOME)/lib/glut -lglut -lGL -lGLU -lXmu

#Note on Solaris:
#SOLARISFLAGS= -L/usr/ucblib -lucb -R/usr/ucblib -lnsl -lsocket
#are needed for some programs on Solaris; but not this one -- they're poison
#for Evolver!

#-----------------------------------------------------------------------------

# Remove #'s from following 3 lines for DEC Alpha with X-windows 
# Add -DOOGL to CFLAGS if you have the X version of geomview.
#CFLAGS= -DDECALPHA -O -Olimit 2000
#GRAPH= xgraph.o
#GRAPHLIB= -lX11

#-----------------------------------------------------------------------------

# IRIX 4, with old gl graphics
# Remove #'s from the following three lines for Iris workstations with 
# geomview.  Those with R4000 CPUs or above may add -mips2 to CFLAGS.
#CFLAGS = -DIRIS -DOOGL -O2 -Olimit 3000 
#GRAPH= iriszgraph.o
#GRAPHLIB=  -lgl_s -lmalloc -lc_s

#-----------------------------------------------------------------------------

# IRIX 5
# Remove #'s from the following three lines for Iris workstations with 
# geomview.  Those with R4000 CPUs or above may add -mips2 to CFLAGS.
#CFLAGS = -DIRIS -DOOGL -O2 -Olimit 3000 
#GRAPH= xgraph.o
#GRAPHLIB=   -lmalloc -lX11

#-----------------------------------------------------------------------------

# IRIX 5, parallel
# Remove #'s from the following three lines for Iris workstations with 
# multiple processors and geomview.  OK for single processors, too.
# Those with R4000 CPUs or above may add -mips2 to CFLAGS.
#CFLAGS = -DIRIS -DOOGL -DSGI_MULTI -O2 -Olimit 3000 -mips2
#GRAPH= xgraph.o
#GRAPHLIB=   -lmalloc -lX11

#-----------------------------------------------------------------------------

# IRIX 6
# Remove #'s from the following three lines for Iris workstations with 
# IRIX 6.x operating system.  Add -DSGI_MULTI to CLFAGS if you
# have multiple processors.
#CFLAGS = -DIRIS -DOOGL -O2 -OPT:Olimit=10000
#GRAPH= xgraph.o
#GRAPHLIB=   -lmalloc -lX11

#-----------------------------------------------------------------------------


# Remove #'s from following 3 lines for  HP workstation
# Omit -Aa if you're using gcc
#CFLAGS= -Aa  -D_HPUX_SOURCE  -I/usr/include/X11R5
#GRAPH= xgraph.o
#GRAPHLIB= -L/usr/lib/X11R5 -lX11

#-----------------------------------------------------------------------------

# Remove #'s from following 3 lines for NeXTStep without screen graphics
# (see separate ftp archive evolver.next.tar.Z for graphics version)
#CFLAGS= -DNeXT
#GRAPH= nulgraph.o 
#GRAPHLIB= 

#-------------------End of system-specific options----------------------------

OBJ= calcforc.o  variable.o trirevis.o  stringl.o stringq.o model.o\
	 fixvol.o query.o matrix.o grapher.o painter.o filml.o filmq.o\
	 torvol.o lexinit.o graphgen.o modify.o userio.o boundary.o\
         curtest.o display.o yexparse.o lexyy.o ytab.o hessian.o\
	 evaltree.o cnstrnt.o verpopst.o popfilm.o machine.o veravg.o \
	 pixgraph.o tmain.o  tordup.o wulff.o help.o psgraph.o check.o  \
	 utility.o skeleton.o  storage.o dump.o iterate.o filgraph.o zoom.o\
         softimag.o mvgraph.o  diffuse.o sqcurve.o klein.o\
	 command.o hidim.o simplex.o metric.o torus.o quotient.o alice.o\
	 sdrv.o odrv.o userfunc.o kusner.o  simequi2.o\
	 geomgraph.o symtable.o exprint.o quantity.o meanint.o mindeg.o\
	 dodecGroup.o registry.o khyp.o gauss.o knot1.o eval_all.o\
	 lexinit2.o evalmore.o knot2.o knot3.o teix.o sqcurve2.o\
	 hessian2.o hessian3.o method1.o method2.o method3.o  bk.o\
	 method4.o method5.o eval_sec.o sqcurve3.o metis.o lagrange.o


evolver: makemark  $(OBJ)  $(GRAPH)
	$(CC) $(CFLAGS)  $(OBJ) $(GRAPH) $(GRAPHLIB) -o evolver -lm   

# This is to get global dependencies on the main header files.
makemark: skeleton.h storage.h model.h web.h
	if [[ -z "$(GRAPH)" ]] ; then (echo "ERROR: You need to uncomment your system's lines in Makefile.") ; fi
	rm *.o || true
	touch makemark

.c.o:
	$(CC) $(CFLAGS) -c  $<
 

# lexyy.c and ytab.c should only be remade when interface
# language is changed, which users shouldn't be touching.
#lexyy.c: datafile.lex express.h ytab.c lex.h
#	lex datafile.lex
#	sed '/#ident/d' <lex.yy.c >t.c
#	sed '/int \* p, int m/s/(int \* p, int m)/(p,m) int *p,m;/' <t.c >lexyy.c
#	rm lex.yy.c

#ytab.c:  command.yac  express.h
#	yacc -d command.yac
#	sed '/#ident/d' <y.tab.c >tmp.c
#	sed '/malloc()/d' <tmp.c >ytab.c
#	rm tmp.c
#	cp y.tab.h ytab.h
#	rm y.tab.c y.tab.h

ytab.h: ytab.c 

lexinit.o: lex.h lexinit.c express.h ytab.h

query.o: lex.h ytab.h query.c

evaltree.o: evaltree.c lex.h ytab.h express.h

eval_all.o: eval_all.c lex.h ytab.h express.h

eval_sec.o: eval_all.c lex.h ytab.h express.h

yexparse.o: yexparse.c lex.h ytab.h express.h

exprint.o: exprint.c lex.h ytab.h express.h

tmain.o: tmain.c include.h

=== debian/changelog ===
evolver (2.70+ds-10) unstable; urgency=medium

  * Upload to unstable.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 17 Aug 2025 18:11:45 +0000

evolver (2.70+ds-9) experimental; urgency=medium

  [ Jerome Benoit ]
  * Introduce d/README.source .
  * Refresh copyright year-tuples.
  * Bump standards version to 4.7.2 in d/t/control.in, no changes needed.
  * Update architecture related lists.
  * Remove constraints unnecessary since buster (oldstable) in d/t/control.in:
    + evolver-nox: Drop versioned constraint on evolver in Breaks,
    + evolver-ogl: Drop versioned constraint on evolver in Breaks.
  * Update d/control (see target update-debian-control in d/rules).
  * Harden d/p/upstream-buildmachinery-src_Makefile-adjustment.patch
    (Closes: #1105314).
  * Intropuce d/p/upstream-fix-migration_to_C23-cleanup.patch
    (Closes: #1096598).
  * Harden d/rules, thanks to Helmut Grohne <helmut@subdivi.de>,
    (Closes: #930206).

  [ Debian Janitor ]
  * Update renamed lintian tag names in lintian overrides.

 -- Jerome Benoit <calculus@rezozer.net>  Thu, 05 Jun 2025 12:55:47 +0000

evolver (2.70+ds-8) unstable; urgency=medium

  * debianization:
    - d/watch:
      - URL target, update;
    - d/control:
      - Homepage, update;
      - Standards-Version, bump to version 4.5.1 (no change);
    - d/copyright:
      - copyright year tuples, update;
    - d/upstream/metadata:
      - URL, secure.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 21 Feb 2021 15:06:04 +0000

evolver (2.70+ds-7) unstable; urgency=medium

  * Debianization:
    - d/t/control:
      - Architecture field for long double precision tests, refine.

 -- Jerome Benoit <calculus@rezozer.net>  Thu, 19 Nov 2020 13:57:35 +0000

evolver (2.70+ds-6) unstable; urgency=medium

  * Debianization:
    - d/t/control:
      - Architecture field for quad precision tests, introduce.

 -- Jerome Benoit <calculus@rezozer.net>  Wed, 18 Nov 2020 20:50:26 +0000

evolver (2.70+ds-5) unstable; urgency=medium

  * FTBFS fix version, gcc-10 venue, fix faulty patch (Closes:  #957186).
  * Debianization:
    - d/templates/*:
      - d/t/tcontrol.in:
        - debhelper, bump tu 13 (no change);
        - Standards-Version, bumpt to version 4.5.0 (no change);
        - Rules-Requires-Root, introduce and set to no;
        - d/t/evolver-FLAVOUR.lintian-overrides.in, empty;
    - d/patches/*:
      - d/p/upstream-source-display-short_description.patch, FTBFS fix;
      - d/p/upstream-source-contrib-EVOLVERPATH.patch, minor fix;
      - d/p/debianization-*.patch:
        - Forwarded field, add and specify as 'not-needed';
    - d/copyright:
      - copyright year tupls, update;
    - d/changelog, quote malformed email addresses as dtected by lintian;
    - d/evolver-doc.lintian-overrides, discard;
    - d/upstream/metadata, introduce.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 14 Nov 2020 20:39:09 +0000

evolver (2.70+ds-4) unstable; urgency=medium

  [ Jelmer Vernooĳ ]
  * Change priority extra to priority optional.
  * Use secure copyright file specification URI.

  [ Jerome Benoit ]
  * Debianization:
    - debian/copyright:
      - Copyright year-tuple, update;
    - debian/{control,templates/control.in}:
      - debhelper, bump to 11;
      - Standards-Version, bump to 4.3.0 (no change);
      - Homepage field, secure;
      - Vcs-* field, migration to salsa;
    - debian/rules:
      - debhelper, bump to 11;
      - pkg-info.mk, include;
      - get-orig-source target, discard;
    - debian/tests/control, introduce;
    - debian/watch:
      - option, compression, add;
    - debian/source/*:
      - lintian-overrides, refresh;
    - debian/{evolver-doc.doc-base,adhoc/Makfile,man/evolver.h2m,
        patches/debianization-build.patch}, debhelper, bump to 11.

 -- Jerome Benoit <calculus@rezozer.net>  Mon, 31 Dec 2018 14:06:09 +0000

evolver (2.70+ds-3) unstable; urgency=medium

  * FTBFS fix release (#Closes: 849945), (temporarily) neutralize ld build
    for ppc64el.

 -- Jerome Benoit <calculus@rezozer.net>  Mon, 30 Jan 2017 18:31:49 +0000

evolver (2.70+ds-2) unstable; urgency=medium

  * FTBFS fixes release:
    - disable PROFILING on i386 architectures (Closes: #832538);
    - isolate architectures without sysinfo function (Closes: #832540);
    - manage quadruple floating point format support (Closes: #832638).
  * Debianization:
    - debian/patches/:
      - d/p/upstream-source-C2help2man.patch, slightly revisit.

 -- Jerome Benoit <calculus@rezozer.net>  Thu, 28 Jul 2016 00:43:59 +0000

evolver (2.70+ds-1) unstable; urgency=medium

  * New maintainer (Closes: #829082).
  * New upstream version (Closes: #745700).
  * Debianization:
    - debian/compat:
      - bump to level 9;
    - debian/copyright:
      - bump format to DEP-5;
      - refresh;
    - debian/control:
      - Standards Version, bump to 3.9.8;
      - Vcs-* headers, secure;
    - debian/watch, revisit;
    - debian/repack, introduce;
    - debian/rules:
      - bump to a fully oriented debhelper script;
      - default target, introduce;
      - get-orig-source target, introduce;
      - build-arch/build-indep scheme, introduce;
      - dpkg-buildflags, set hardening=+all;
    - debian/patches/:
      - bump format to DEP-3;
      - d/p/manpage.patch, revisit
          and rename d/p/upstream-source-manpage.pacth;
      - d/p/debian-opengl.patch, improve
          and rename d/p/debianization-build.patch;
      - d/p/install-doc.patch, revisit
          and rename d/p/debianization-documentation.patch;
      - d/p/example-path.patch, discard in favour of
          d/p/upstream-source-contrib-EVOLVERPATH.patch;
      - d/p/upstream-*.patch, introduce (and submit);
      - d/p/debianization-*.patch, introduce;
    - debian/adhoc/Makefile, introduce;
    - debian/man/evolver.h2m, introduce;
    - refresh.
  * Upstream fixes and enhancements has been submitted to the
    upstream maintainer.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 17 Jul 2016 18:21:13 +0000

=== debian/control ===
Source: evolver
Section: math
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jerome Benoit <calculus@rezozer.net>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13), help2man,
 libquadmath0 [amd64 i386 ia64 ppc64el x32],
 libreadline-dev,
 freeglut3-dev | libglut-dev
Build-Depends-Indep:
 rdfind, symlinks
Standards-Version: 4.7.2
Homepage: https://kenbrakke.com/evolver/evolver.html
Vcs-Git: https://salsa.debian.org/science-team/evolver.git
Vcs-Browser: https://salsa.debian.org/science-team/evolver

Package: evolver
Architecture: all
Multi-Arch: foreign
Depends: evolver-nox | evolver-ogl , ${misc:Depends}
Description: Surface Evolver
 The Surface Evolver is an interactive program for the modelling of liquid
 surfaces shaped by various forces and constraints.
 .
 This dummy package provides the standard installation.

Package: evolver-nox
Provides: evolver
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: geomview
Suggests: evolver-doc
Description: Surface Evolver - with no X support
 The Surface Evolver is an interactive program for the modelling of liquid
 surfaces shaped by various forces and constraints.
 .
 This package provides evolver variants built with different floating point
 formats (double, long double, quadruple) but with no X support.

Package: evolver-ogl
Provides: evolver
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: geomview
Suggests: evolver-doc
Description: Surface Evolver - with OpenGL display
 The Surface Evolver is an interactive program for the modelling of liquid
 surfaces shaped by various forces and constraints.
 .
 This package provides evolver variants built with different floating point
 formats (double, long double, quadruple) and with an OpenGL/GLUT display.

Package: evolver-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: pdf-viewer, www-browser
Enhances: evolver-nox, evolver-ogl
Description: Surface Evolver - doc
 The Surface Evolver is an interactive program for the modelling of liquid
 surfaces shaped by various forces and constraints.
 .
 This package provides the documentation and the on-line help content for the
 evolver front-end program, as well as examples.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_ARCH_REVLISTOF_LIBQUAMATH ?= amd64 i386 ia64 ppc64el x32

export DEB_PKG_VERSION = $(DEB_VERSION)
export UPS_PKG_VERSION = $(firstword $(subst +ds, ,$(DEB_PKG_VERSION)))
export UPS_PKG_VERSION_INT = $(subst .,,$(UPS_PKG_VERSION))

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

DEB_VIRT_EVOLVER_FLAVOUR_VARIANT_LISTOF_DHFILE = .install .manpages
DEB_VIRT_EVOLVER_FLAVOUR_FLAVOUR_LISTOF_DHFILE = .lintian-overrides .postinst .prerm .README.Debian
DEB_VIRT_EVOLVER_LISTOF_FLAVOUR = nox ogl
DEB_VIRT_EVOLVER_LISTOF_FLOATINGPOINTFORMAT = d
ifneq ($(DEB_HOST_ARCH), ppc64el)
DEB_VIRT_EVOLVER_LISTOF_FLOATINGPOINTFORMAT += ld
endif
ifneq (,$(filter $(DEB_HOST_ARCH),$(DEB_ARCH_REVLISTOF_LIBQUAMATH)))
DEB_VIRT_EVOLVER_LISTOF_FLOATINGPOINTFORMAT += q
endif

# deduced variables
DEB_VIRT_EVOLVER_FLAVOUR_LISTOF_DHFILE = \
	$(DEB_VIRT_EVOLVER_FLAVOUR_VARIANT_LISTOF_DHFILE) \
	$(DEB_VIRT_EVOLVER_FLAVOUR_FLAVOUR_LISTOF_DHFILE)
DEB_VIRT_EVOLVER_LISTOF_VARIANT = \
	$(foreach ef, $(DEB_VIRT_EVOLVER_LISTOF_FLAVOUR), \
		$(foreach fpf, $(DEB_VIRT_EVOLVER_LISTOF_FLOATINGPOINTFORMAT), \
			$(ef)-$(fpf) \
			) \
		)
#

CFLAGS := $(subst -O2,-O3,$(CFLAGS))


SED_KEY_FLAVOUR_nox = NOX
SED_KEY_FLAVOUR_ogl = GLUT
SED_KEY_FPF_d = UNDEFINED
SED_KEY_FPF_ld = LONGDOUBLE
SED_KEY_FPF_q = FLOAT128

default:
	@uscan --no-conf --dehs --report || true

%:
	dh $@ --builddirectory=_build

override_dh_auto_configure-arch:
	mkdir -p $(foreach ev, $(DEB_VIRT_EVOLVER_LISTOF_VARIANT), _build/$(ev)/src )
	$(foreach ef, $(DEB_VIRT_EVOLVER_LISTOF_FLAVOUR), \
		$(foreach fpf, $(DEB_VIRT_EVOLVER_LISTOF_FLOATINGPOINTFORMAT), \
			sed \
					-e "s|#>$(SED_KEY_FLAVOUR_$(ef))<#||g" \
					-e "s|#>>$(SED_KEY_FPF_$(fpf))<<#||g" \
				src/Makefile > _build/$(ef)-$(fpf)/src/Makefile \
			$(NEWLINE) ) \
		)

override_dh_auto_build-arch:
	$(foreach ev, $(DEB_VIRT_EVOLVER_LISTOF_VARIANT), \
		EXEC_SUFFIX=-$(ev) VPATH=../../../src \
		dh_auto_build --builddirectory=_build/$(ev)/src  \
		$(NEWLINE) )

override_dh_prep-arch:
	mkdir -p _build/DEBIAN
	$(foreach ev, $(DEB_VIRT_EVOLVER_LISTOF_VARIANT), \
		$(eval _ef:=$(firstword $(subst -, $(EMPTY), $(ev)))) \
		$(foreach dhf, $(DEB_VIRT_EVOLVER_FLAVOUR_VARIANT_LISTOF_DHFILE), \
			sed \
					-e "s|@VARIANT@|$(ev)|g" \
				debian/templates/evolver-FLAVOUR$(dhf).in >> debian/evolver-$(_ef)$(dhf) \
			$(NEWLINE) ) \
		)
	$(foreach ef, $(DEB_VIRT_EVOLVER_LISTOF_FLAVOUR), \
		$(foreach dhf, $(DEB_VIRT_EVOLVER_FLAVOUR_FLAVOUR_LISTOF_DHFILE), \
			sed \
					-e "s|@FLAVOUR@|$(ef)|g" \
					-e "s|@LISTOF_VARIANT@|$(filter $(ef)%, $(DEB_VIRT_EVOLVER_LISTOF_VARIANT))|g" \
				debian/templates/evolver-FLAVOUR$(dhf).in > debian/evolver-$(ef)$(dhf) \
			$(NEWLINE) ) \
		)
	$(foreach ev, $(DEB_VIRT_EVOLVER_LISTOF_VARIANT), \
		$(MAKE) -C _build/DEBIAN -f ../../debian/adhoc/Makefile manpages VARIANT=$(ev) TOP_SRCDIR=../.. VPATH=../$(ev)/src $(NEWLINE) \
		)
	dh_prep -a

override_dh_auto_build-indep:

override_dh_auto_install-arch:
	$(foreach ev, $(DEB_VIRT_EVOLVER_LISTOF_VARIANT), \
		$(MAKE) -f debian/adhoc/Makefile install-exec VARIANT=$(ev) TOP_BUILDDIR=_build/$(ev) DESTDIR=debian/tmp $(NEWLINE) \
		)

override_dh_auto_install-indep:
	$(MAKE) -f debian/adhoc/Makefile install-doc DESTDIR=debian/tmp

override_dh_link-indep:
	dh_link -p evolver-doc \
		/usr/share/doc/evolver/manual$(UPS_PKG_VERSION_INT).pdf /usr/share/doc/evolver/manual.pdf \
		/usr/share/doc/evolver/examples /usr/share/doc/evolver/fe

override_dh_compress-indep:
	dh_compress -Xevhelp.txt -X.pdf -Xexamples

override_dh_auto_clean-arch:
	dh_auto_clean -a
	rm -rf _build
	rm -f $(foreach ev, $(DEB_VIRT_EVOLVER_LISTOF_FLAVOUR), $(foreach dhf, $(DEB_VIRT_EVOLVER_FLAVOUR_LISTOF_DHFILE), debian/evolver-$(ev)$(dhf) ))

update-debian-control: debian/templates/control.in debian/rules
	sed \
			-e "s|@braCSket_DEB_ARCH_REVLISTOF_LIBQUAMATH@|[$(DEB_ARCH_REVLISTOF_LIBQUAMATH)]|g" \
		$< > debian/control


define NEWLINE


endef

EMPTY :=
EMPTY +=

=== debian/tests/control ===
Test-Command: echo "g 5; v; r ; g 10; v;" | evolver cube
Depends: evolver, evolver-doc

Test-Command: echo "g 5; v; r ; g 10; v;" | evolver-nox-d cube
Depends: evolver-nox, evolver-doc

Test-Command: echo "g 5; v; r ; g 10; v;" | evolver-ogl-d cube
Depends: evolver-ogl, evolver-doc

Test-Command: echo "g 5; v; r ; g 10; v;" | evolver-nox-ld cube
Architecture: !ppc64el
Depends: evolver-nox, evolver-doc

Test-Command: echo "g 5; v; r ; g 10; v;" | evolver-ogl-ld cube
Architecture: !ppc64el
Depends: evolver-ogl, evolver-doc

Test-Command: echo "g 5; v; r ; g 10; v;" | evolver-nox-q cube
Architecture: amd64 i386 ia64 ppc64el x32
Depends: evolver-nox, evolver-doc

Test-Command: echo "g 5; v; r ; g 10; v;" | evolver-ogl-q cube
Architecture: amd64 i386 ia64 ppc64el x32
Depends: evolver-ogl, evolver-doc

=== debian/watch ===
version=3
opts=dversionmangle=s/\+ds$//,compression=xz,repacksuffix=+ds \
https://facstaff.susqu.edu/brakke/evolver/evolver.html (?:.*/)?evolver[_\-\.]?(\d\S+)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz)) \
debian bash debian/repack
